#!/usr/bin/env groovy
if (this.args.size() < 3){
  println("usage: compareExpectedWLog workload-file-name wkld-actor-id actor-log-filename");
  return;
}
wkldFileName = this.args[0];
actorId = this.args[1];
logFileName = this.args[2];
boolean details = false;
if (this.args.size() == 4) {    
    if (this.args[3] == "details") details = true;
}
wkldFile = new File(wkldFileName);
logFile = new File(logFileName);
wkldRegExp = actorId + ",MATCH";
attrRegExp = /[a-z]{1} \w+ \w+/;
//getting 0: { Corinthianizes=58 absolution=85 tedious=92}
logRegExp = /getting \d+: \{/;
logAttrRegExp = /\w+=\"*\w+\"*/;
expected = new ArrayList();
log = new ArrayList();
int rec = 0;
int pub = 0;
int sub = 0;

if(details){
println("compareExpectedWLog");
    for (a in this.args) {
      println("Argument: " + a);
    }
}

for(line in wkldFile.readLines()){
    if (line =~ wkldRegExp){
      //println(" Found match in line: " + line);
      attributes = new HashMap();
      line.eachMatch(attrRegExp){
         //println(" attribute: " + it[0]);
         attrArray = it[0].split(" ");
         attributes.put(attrArray[1],attrArray[2]);
      }    
    //println("attributes: " + attributes);
    expected.add(attributes);
    }  
}

for(line in logFile.readLines()){
    if (line =~ logRegExp){
      //println(" Found match in log line: " + line);
      attributes = new HashMap();
      line.eachMatch(logAttrRegExp){
         //println(" attribute: " + it[0]);
         attrArray = it[0].split("=");
         attributes.put(attrArray[0],attrArray[1].replaceAll('\"',{""}));
      }    
    //println("attributes: " + attributes);
    log.add(attributes);    
    } else if (line =~ /subscribing for/) {
        sub++;
    } else if (line =~ /publishing/) {
        pub++;
    }
}

println("sub:${sub}");
println("pub:${pub}");
println("received:${log.size()}");
println("expected:${expected.size()}");
expected_c = expected.clone();
expected.removeAll(log);
log.removeAll(expected_c);
println("falseNeg:${expected.size()}");
println("falsePos:${log.size()}");
if(details){
    println("expected - log (undelivered msg | false negatives) [" + expected.size() + "]: " + expected);
    println("log - expected (unexpected msg | false positives ) [ "  + log.size() + "]: " + log);
}
    
/*printFileLine = { println "File line: " + it }
matchFileLine = {if (it ==~ wkldRegExp) printFileLine}

wkldFile.eachLine( matchFileLine )
*/

