#!/usr/bin/env groovy
package siena;

println("extractControlTrafficPlotData");

if (this.args.size() < 4){
  println("usage: extractControlTrafficPlotData mergedLogFileName control-traffic-data-series percentage-control-traffic-data-series period");
  return;
}
for (a in this.args) {
  println("Argument: " + a);
}

logFile = new File(args[0]);
dataFile = new File(args[1]);
dataFile.write("time" + "\t" +  "udv" +  "\t" + "dv" +  "\t" + "drp" + "\t" + "pub" + "\t" + "sub" + "\t" + "uns" + "\t" + "cfg" + "\n");
percentageDataFile = new File(args[2]);
percentageDataFile.write("time" + "\t" +  "udv" +  "\t" + "dv" +  "\t" + "drp" + "\t" + "pub" + "\t" + "sub" + "\t" + "uns" + "\t" + "cfg" + "\n");
int period = Integer.parseInt(args[3]); // size of the moving average window in milliseconds
lines = logFile.readLines();


//assert "301 D2 subscribing for 0: { influenced >47}" =~ /\d+ (\w+) (\w+).+ \d: (\{.+\})/;
processReqRegExp=/(\d+).+processRequest: senp\{version=1 method=\"(\w+)\"/;
int iteration = 1;
int packetCount = 0;
int udv = 0;
int dv = 0;
int drp = 0;
int pub = 0;
int sub = 0;
int uns = 0;
int cfg = 0;

for(i in 0..lines.size()){
    matcher = (lines[i] =~ processReqRegExp);
    //println(lines[i]);      
    //301 D2 subscribing for 0: { influenced >47}
    //1241 D6 publishing 0: { Corinthianizes=91 msgId="C6m0" sanctum="Oberlin" tedious=8}
    //18078 D1 getting 1: { absolution=65 hedge=97 msgId="C3m1" sanctum=54}
    //20034 D4 unsubscribing 0: SUB(0, `"i identities < 63"')
    //24550 S4 DV/DRP false positive on senp{    
    if (matcher) {
        packetCount++;
        // check if moving average period is over, print results and set counters to 0
        int time = Integer.parseInt(matcher[0][1]);        
        while( time > (iteration * period)){            
            if (packetCount != 0){
                percentageDataFile.append(iteration * period + "\t" +  udv / packetCount +  "\t" + dv / packetCount +  "\t" + drp / packetCount + "\t" + pub / packetCount + "\t" + sub / packetCount + "\t" + uns / packetCount + "\t" + cfg / packetCount + "\n");                
            } else {
                percentageDataFile.append(iteration * period + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\n");                
            } 
            dataFile.append(iteration * period + "\t" +  udv +  "\t" + dv +  "\t" + drp + "\t" + pub + "\t" + sub + "\t" + uns + "\t" + cfg + "\n");
            
            packetCount = 0;
            udv = 0;
            dv = 0;
            drp = 0;
            pub = 0;
            sub = 0;
            uns = 0;
            cfg = 0;
            iteration++;
        }
        //println(matcher[0]);
        switch (matcher[0][2]) {
                            case "DV":
                                dv++;
                                break;
                            case "UDV":
                                udv++;
                                break;
                            case "PUB":
                                pub++;
                                break;
                            case "SUB":
                                sub++;
                                break;
                            case "DRP":
                                drp++;
                                break;
                            case "CNF":
                                cfg++;
                                break;
                            case "UNS":
                                uns++
                        }
        
    }
    // go to next line
    i++;
}

if (packetCount != 0){
  percentageDataFile.append(iteration * period + "\t" +  udv / packetCount +  "\t" + dv / packetCount +  "\t" + drp / packetCount + "\t" + pub / packetCount + "\t" + sub / packetCount + "\t" + uns / packetCount + "\t" + cfg / packetCount + "\n");                
} else {
  percentageDataFile.append(iteration * period + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\t " + 0 + "\n");                
} 
dataFile.append(iteration * period + "\t" +  udv +  "\t" + dv +  "\t" + drp + "\t" + pub + "\t" + sub + "\t" + uns + "\t" + cfg + "\n");
