#!/usr/bin/env groovy

println("findInconsitencies");

if (this.args.size() < 3){
  println("usage: findInconsitencies workloadFile.wkld actorID logFileName");
  return;
}
for (a in this.args) {
  println("Argument: " + a);
}


wkldFileName = this.args[0];
actorId = this.args[1];
logFileName = this.args[2];
wkldFile = new File(wkldFileName);
logFile = new File(logFileName);
//event(168,C1
wkldRegExp = "event\\(\\d+," + actorId;
indexRegExp = /,`(PUB|SUB|UNS)\((\d+)/;
attrRegExp = /[a-z]{1} \w+ \w+/;
//getting 0: { Corinthianizes=58 absolution=85 tedious=92}
logRegExp = /(subscribing for|publishing|getting|unsubscribing) (\d+)/;
logAttrRegExp = /(\w+)=\"*(\w+)\"*/;
expected = new ArrayList();
log = new ArrayList();

for(line in wkldFile.readLines()){
    if (line =~ wkldRegExp){      
      //event(182,C4,`SUB(0, `"i Corinthianizes > 80"')',,)
      //event(1039,C4,`PUB(0, `"s identities agonize & i sanctity 34 & s sanctum live"')',,)
      if(line =~ indexRegExp){
          //println("line: " + line);
          matcher = (line =~ indexRegExp);          
          //println(" entry: " + matcher[0]);
          entry = [(matcher[0][1]) : (matcher[0][2])];
          expected.add(entry);          
      } else {
            attributes = new HashMap();
            line.eachMatch(attrRegExp){
                //println(" attribute: " + it[0]);
                attrArray = it[0].split(" ");
                attributes.put(attrArray[1],attrArray[2]);
            }
            expected.add(attributes);
      }       
    //println("attributes: " + attributes);    
    }  
}

println("expected: " + expected);

for(line in logFile.readLines()){
    if (line =~ logRegExp){
      //println(" Found match in log line: " + line);
      matcher = (line =~ logRegExp);
      //println("matcher: " + matcher[0]);
      //assert matcher[0][1] ==~ "subscribing for";
      if (matcher[0][1] ==~ /subscribing for/){          
          entry = [("SUB") : (matcher[0][2])];
          log.add(entry);
      } else if (matcher[0][1] ==~ /unsubscribing/){
          entry = [("UNS") : (matcher[0][2])];
          log.add(entry);
      }else if (matcher[0][1] ==~ /publishing/) {
          entry = [("PUB") : (matcher[0][2])];
          log.add(entry);
      } else {
          attributes = new HashMap();
          //println(" line: " + line);
          attrMatcher = (line =~ logAttrRegExp);      
          attrMatcher.each({ wholeThing, attrName, attrValue -> attributes.put(attrName,attrValue);});
          log.add(attributes);
      }
      
   }
}

println("log: " + log);

for (i in 0..<expected.size()){
    int pos = log.indexOf(expected[i]);
    if ( pos != i){
        println("Entry expected at " + i + " logged at " + pos + " :" + expected[i]);
    }
}

/*expected_c = expected.clone();
expected.removeAll(log);
println("expected - log (undelivered msg | false negatives) [" + expected.size() + "]: " + expected);
log.removeAll(expected_c)
println("log - expected (unexpected msg | false positives ) [ "  + log.size() + "]: " + log);
*/
    
/*printFileLine = { println "File line: " + it }
matchFileLine = {if (it ==~ wkldRegExp) printFileLine}

wkldFile.eachLine( matchFileLine )
*/

