#!/usr/bin/env groovy

println("mergeLogs");

if (this.args.size() < 2){
  println("usage: mergeLogs logFileName [logFileName]+ mergedLogFileName");
  return;
}
for (a in this.args) {
  println("Argument: " + a);
}

dateRegExp = /(\d{4}-\d{2}-\d{2} \d{2}\:\d{2}\:\d{2}\:\d{3} .\d{4})(.+)/;
java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(dateRegExp);

class Merger {
    List lines = new ArrayList();            
    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS Z");
    java.util.regex.Pattern pattern;    
    
    public Merger(List fileNames, java.util.regex.Pattern datePattern){
        this.pattern = datePattern;
        for(i in 0..fileNames.size()-1){
            //println(fileNames[i] + " pos: " + i);
            File file = new File(fileNames[i]);            
            List onlyEvents = file.readLines().findAll({it =~ datePattern})
            lines.addAll(onlyEvents);    
        }        
        lines.sort();
    }
    
    List convertTimes(){
        java.util.regex.Matcher m = (lines[0] =~ pattern); 
        if (m){
            List result = new java.util.ArrayList();
            String strDate = m[0][1];
            Date start = sdf.parse(strDate);           
            for(line in lines){
                java.util.regex.Matcher m2 = (line =~ pattern);
                if(m2){
                   String lineDate = m2[0][1];
                   Date curr = sdf.parse(lineDate);                   
                   //println(curr);
                   //println(start);
                   long millis = curr.getTime() - start.getTime();
                   //println(millis);                   
                   line = millis + m2[0][2];
                   // remove trailing exceptions for closed sockets
                   if (!(line =~ /non-fatal error in packet receiver/)){
                       result.add(line);
                   }
                }                
            }
            return result;
        }
    }
    
    void restoreCausality(){  
        lines.sort();        
        File tempFile = new File("_mergeTemp");
        tempFile.write("");
        lines.each({tempFile.append(it + "\n")});
        for(i in 0..lines.size()){
            java.util.regex.Matcher match = (lines[i] =~ /(\d{4}-\d{2}-\d{2} \d{2}\:\d{2}\:\d{2}\:\d{3} .\d{4}).*publishing.+msgId=\"(\w+)\"/);
            if (match){
                //println(lines[i]);
                Date time = sdf.parse(match[0][1]);                
                String msgId = match[0][2];
                // use grep to find DRP messages (and false positives) with this ID
                String[] cmd = ["sh","-c","grep -n -E '.+msgId=\"${msgId}\"' _mergeTemp"];
                //println(cmd);
                cmd.execute().in.eachLine(){   
                    //println(it);
                    java.util.regex.Matcher drpMatch = (it =~ '(\\d+).+msgId=\"' + msgId + '\\"');
                    if(drpMatch){
                        //position of the matched line                            
                        int pos = Integer.parseInt(drpMatch[0][1]);
                        pos--; // grep's indexed are 1-based
                        //then we change the time info
                        int ttl = 0;
                        //println(drpMatch);
                        drpMatch[0][0].eachMatch(/ttl=(\d+)/,{ttl = Integer.parseInt(it[1])});
                        if (ttl == 0){
                            //not all lines have a ttl
                            //if it's the original publication we leave it as is (ttl = 31)                            
                            //if it's a message reception we posptone it (ttl < 30)
                            ttl = (drpMatch[0][0] =~ /publishing/) ? 31 : 25;                            
                        }
                        //println("ttl = ${ttl}" );
                        Date newtime = new Date();
                        newtime.setTime(time.getTime() + 1 + (30 - ttl));
                        //println(lines[pos]);
                        lines[pos] = lines[pos].replaceAll(/^(\d{4}-\d{2}-\d{2} \d{2}\:\d{2}\:\d{2}\:\d{3} .\d{4})/, sdf.format(newtime));
                        //println(lines[pos]);
                    }                        
                };
                
            }
          i++;
        }
        lines.sort();        
    }
    
    void print(File output){
        for (i in lines){
            output.append(i + "\n");
        }
    }
}    


outputFile = new File(args[args.size() - 1]);
outputFile.write("");
Merger mg = new Merger(args[0..args.size()-2], pattern);
mg.restoreCausality()
List converted = mg.convertTimes();
for (i in converted){
   outputFile.append(i + "\n");
}
