package siena;
import java.text.SimpleDateFormat;
import java.util.Date;

import siena.comm.KAPacketReceiver;
import siena.comm.PacketReceiver;
import siena.comm.TCPPacketReceiver;
import siena.comm.UDPPacketReceiver;
import weevil.Actor;

public class SienaActorThinClient implements Actor, Notifiable{
	////////////input arguments/////////////	
	ThinClient client;

	public String server_protocol, server_ip, my_identity;
	public int server_port, client_port;

	int index;

	Filter[] sublist;
	String sub_type, sub_subject, sub_op, sub_value;
	Date subdate;
	long subtime;

	Date unsubdate;
	long unsubtime;

	Notification e;
	String pub_type, pub_subject, pub_value;
	Date pubdate;
	long pubtime;

	public int eventid = 0;
	
	static SimpleDateFormat sdf = new SimpleDateFormat(
	"yyyy-MM-dd HH:mm:ss:SSS Z");

	public SienaActorThinClient( String arg ){
		//parse arg
		String[] configparser = arg.split(" ");
		server_protocol = configparser[0];
		server_ip = configparser[1];
		server_port = Integer.parseInt(configparser[2]);
		client_port = Integer.parseInt(configparser[3]);		
		my_identity = configparser[4];
		////////////////system specific/////////////	 	
		String master = server_protocol+":"+server_ip+":"+server_port;
		try{
			PacketReceiver pr = null;
			if (server_protocol.equals("tcp")){
				TCPPacketReceiver tpr = new TCPPacketReceiver(client_port);
				// actor is co-located with server
				tpr.setHostName(server_ip);
				pr = tpr;
			}	else if (server_protocol.equals("udp")) {
				UDPPacketReceiver upr = new UDPPacketReceiver(client_port);
//			 	actor is co-located with server
				upr.setHostName(server_ip);
				pr = upr;
			} else if (server_protocol.equals("ka")) {
				KAPacketReceiver kpr = new KAPacketReceiver(client_port);
				kpr.setHostName(server_ip);
				pr = kpr;
			}			
			client = new ThinClient(master);				  		
			Logging.setLogStream(System.out);
			Logging.setErrorStream(System.err);
			sublist = new Filter[100];
		} catch (Exception ex){
			System.err.println("Exceptions:" + ex.toString());
		}
	}

	public void action(String arg){
		System.out.println(sdf.format(new Date()) + " " + my_identity + " executing action: " + arg);
		String command = arg.substring(0, arg.indexOf('('));
		String argument = arg.substring(arg.indexOf('(')+1, arg.lastIndexOf(')'));
		if (command.equals("SUB")){
			subAction(argument);
		}
		else if (command.equals("PUB")){
			pubAction(argument);
		}
		else if (command.equals("UNS")){
			unsubAction(argument);
		}
	}

	public void stop(){
		client.shutdown();
	}

    public void notify(Notification e) {
		System.out.println(sdf.format(new Date()) + " " + my_identity + " getting " + eventid + ": " + e.toString());
		eventid++;
    };

    public void notify(Notification [] s) { }

	public void subAction(String arg){
		//////////////parsing////////////////
		//subscription
		index = Integer.parseInt(arg.substring(0, arg.indexOf(',')));
		sublist[index] = new Filter();
		String newthisLine = arg.substring(arg.indexOf('"')+1, arg.lastIndexOf('"'));
		String constr;
		int constr_index, blank_index, sub_value_int;
		short sub_op_short;
		boolean sub_value_bool;
		boolean loop = true;

		while ((newthisLine.indexOf('&') >= 0)||(loop)){
			if (newthisLine.indexOf('&') < 0){
				loop = false;
				constr = newthisLine;
			}
			else{
				constr_index = newthisLine.indexOf('&');
			 	constr = newthisLine.substring(0, constr_index-1);
			  	newthisLine = newthisLine.substring(constr_index+2,newthisLine.length());
			}
			//sub_type
			blank_index = constr.indexOf(' ');
			sub_type = constr.substring(0, blank_index);
			//sub_subject
			constr = constr.substring(blank_index+1, constr.length());
			blank_index = constr.indexOf(' ');
			sub_subject = constr.substring(0, blank_index);
			//sub_op
			constr = constr.substring(blank_index+1, constr.length());
			blank_index = constr.indexOf(' ');
			sub_op = constr.substring(0, blank_index);
			//sub_value
			constr = constr.substring(blank_index+1, constr.length());
			blank_index = constr.length();
			sub_value = constr.substring(0, blank_index);

			if (sub_op.equals(">"))
				sub_op_short = Op.GT;
			else if (sub_op.equals("<"))
				sub_op_short = Op.LT;
			else if (sub_op.equals("="))
				sub_op_short = Op.EQ;
			else if (sub_op.equals(">="))
				sub_op_short = Op.GE;
			else if (sub_op.equals("<="))
				sub_op_short = Op.LE;
			else if (sub_op.equals("!="))
				sub_op_short = Op.NE;
			else if (sub_op.equals("PF"))
				sub_op_short = Op.PF;
			else if (sub_op.equals("SF"))
				sub_op_short = Op.SF;
			else //if (sub_op.equals("SS"))
				sub_op_short = Op.SS;

			//////////////client API////////////////
			if (sub_type.equals("i")){
				sub_value_int = Integer.parseInt(sub_value);
				sublist[index].addConstraint(sub_subject, sub_op_short, sub_value_int);
			}
			else if (sub_type.equals("b")){
				if (sub_value.equals("0"))
					sub_value_bool = false;
				else
					sub_value_bool = true;
				sublist[index].addConstraint(sub_subject, sub_op_short, sub_value_bool);
			}
			else
				sublist[index].addConstraint(sub_subject, sub_op_short, sub_value);
		}
		//////////////client log format////////////////
		System.out.println(sdf.format(new Date()) + " " + my_identity +  " subscribing for " + index + ": " + sublist[index].toString());
	 	try {
	 		client.subscribe(sublist[index], this);
		} catch (SienaException ex){
			System.err.println("Siena error:" + ex.toString());
		}
	}

	public void pubAction(String arg){
		//////////////parsing////////////////
		//notification

		e = new Notification();

		index = Integer.parseInt(arg.substring(0, arg.indexOf(',')));
		String newthisLine = arg.substring(arg.indexOf('"')+1, arg.lastIndexOf('"'));
		String constr;
		int constr_index, blank_index, pub_value_int;
		boolean pub_value_bool;
		boolean loop = true;

		while ((newthisLine.indexOf('&') >= 0)||(loop)){
			if (newthisLine.indexOf('&') < 0){
				loop = false;
				constr = newthisLine;
			}
			else{
				constr_index = newthisLine.indexOf('&');
				constr = newthisLine.substring(0, constr_index-1);
				newthisLine = newthisLine.substring(constr_index+2,newthisLine.length());
			}

			//pub_type
			blank_index = constr.indexOf(' ');
			pub_type = constr.substring(0, blank_index);
			//pub_subject
			constr = constr.substring(blank_index+1, constr.length());
			blank_index = constr.indexOf(' ');
			pub_subject = constr.substring(0, blank_index);
			//pub_value
			constr = constr.substring(blank_index+1, constr.length());
			blank_index = constr.length();
			pub_value = constr.substring(0, blank_index);

			if (pub_type.equals("i")){
				pub_value_int = Integer.parseInt(pub_value);
				e.putAttribute(pub_subject, pub_value_int);
			}
			else if (pub_type.equals("b")){
				if (pub_value.equals("0"))
					pub_value_bool = false;
				else
					pub_value_bool = true;
				e.putAttribute(pub_subject, pub_value_bool);
			}
			else{
				e.putAttribute(pub_subject, pub_value);
			}
		}
		//////////////client log format////////////////
	 	System.out.println(sdf.format(new Date()) + " " + my_identity + " publishing " + index + ": " + e.toString());
		//////////////client API////////////////
	 	try {
	 		client.publish(e);
		} catch (SienaException ex) {
			System.err.println("Siena error:" + ex.toString());
	  	}
	}

	public void unsubAction(String arg){
		index = Integer.parseInt(arg.substring(0, arg.indexOf(',')));
		String sub = arg.substring(arg.indexOf(',')+1,arg.indexOf(')')+1); 
		//////////////client API////////////////
		try {
//////////////client log format////////////////		
			System.out.println(sdf.format(new Date()) + " " + my_identity + " unsubscribing for" + index + ": " + sublist[index]);
			client.unsubscribe(sublist[index], this);
		} catch (SienaException e) {
			// TODO Auto-generated catch block
			System.err.println("Error unsubscribing: " + sublist[index]);
			e.printStackTrace();
		}
		
	}
}
